# WebDNN examples

This directory contains some examples to illustrate typical usage of WebDNN.

## Common setup

Before running these examples, you have to install `webdnn` python library and start a HTTP server on the repository root directory.

You can run a HTTP server with standard python feature.

```
python -m http.server
```

## List of Examples

### MNIST training and conversion

`mnist` directory contains the example to train and convert a DNN for classifying the MNIST dataset.

### SqueezeNet model conversion

`squeeze_net` directory contains the example to convert the pre-trained SqueezeNet image classification DNN for WebDNN.

### ResNet-50 model conversion

`resnet` directory contains the example to convert the pre-trained ResNet-50 large-scale image classification DNN for WebDNN.

### Caffe model conversion

`convert_caffe` directory contains the example to convert the CaffeNet large-scale DNN for WebDNN.

This example illustrates how to use Caffe model for WebDNN.

### Neural Style Transfer

`neural_style_transfer` directory contains the example to convert the [Neural Style Transfer model](https://github.com/gafr/chainer-fast-neuralstyle-models) for WebDNN.

This is intended to be example of interactive application.

### Sentence sentiment classification

`lstm` directory contains the example to train and convert LSTM-based model to classify sentiments of movie reviews.

This example illustrates how to use LSTM model.

### Text generation

`text_generation` directory contains the example to convert LSTM-based text generation model to generate text like Nietzsche.

This example illustrates how to iteratively predict character probability and sample a character.

### Benchmark

`benchmark` directory contains the speed benchmark to compare WebDNN with other frameworks.
